=== modified file 'Makefile'
--- Makefile	2011-08-17 22:46:35 +0000
+++ Makefile	2011-10-15 16:48:03 +0000
@@ -5,7 +5,7 @@
 	-Wbad-function-cast -Wcast-qual -Wcast-align -Wwrite-strings \
 	-Wconversion -Wstrict-prototypes -Wold-style-definition \
 	-Wpacked -Wnested-externs -Winline -Wvolatile-register-var
-#	-Wunreachable-code 
+#	-Wunreachable-code
 #DEBUG=-ggdb3
 # For info about _FORTIFY_SOURCE, see
 # <http://www.kernel.org/doc/man-pages/online/pages/man7/feature_test_macros.7.html>
@@ -23,7 +23,7 @@
 OPTIMIZE=-Os
 LANGUAGE=-std=gnu99
 htmldir=man
-version=1.3.1
+version=1.4.1
 SED=sed
 
 ## Use these settings for a traditional /usr/local install
@@ -65,7 +65,9 @@
 	--param man.authors.section.enabled	0 \
 	 /usr/share/xml/docbook/stylesheet/nwalsh/manpages/docbook.xsl \
 	$(notdir $<); \
-	$(MANPOST) $(notdir $@))
+	$(MANPOST) $(notdir $@);\
+	LANG=en_US.UTF-8 MANWIDTH=80 man --warnings --encoding=UTF-8 \
+	--local-file $(notdir $@) >/dev/null)
 # DocBook-to-man post-processing to fix a '\n' escape bug
 MANPOST=$(SED) --in-place --expression='s,\\\\en,\\en,g;s,\\n,\\en,g'
 

=== modified file 'NEWS'
--- NEWS	2011-07-27 17:58:27 +0000
+++ NEWS	2011-10-15 16:48:03 +0000
@@ -1,6 +1,26 @@
 This NEWS file records noteworthy changes, very tersely.
 See the manual for detailed information.
 
+Version 1.4.1 (2011-10-15)
+* Server
+** Make D-Bus properties settable again, and handle checkers
+   for disabled clients correctly.
+* Miscellaneous fixes to "pedantic" Lintian warnings
+
+Version 1.4.0 (2011-10-09)
+* README file migrated to manual page intro(8mandos).
+* Client:
+** Fixed warning about "rmdir: Directory not empty".
+* Server:
+** Default values changed: timeout 5 minutes, interval 2 minutes.
+** Clients gets an expiration extension when receiving a password,
+   controlled by new "extended_timeout" setting.
+** New domain name: "fukt.bsnet.se" changes to "recompile.se".  This
+   also affects the D-Bus bus and interface names (old names still
+   work).  Users should start using the new names immediately.
+** New D-Bus Client object properties "Expires" and "ExtendedTimeout";
+   see DBUS-API for details.
+
 Version 1.3.1 (2011-07-27)
 * Client:
 ** Client now retries all Mandos servers periodically.

=== modified file 'TODO'
--- TODO	2011-09-26 19:36:18 +0000
+++ TODO	2011-10-14 18:00:50 +0000
@@ -16,7 +16,7 @@
 * splashy
 ** TODO [#B] use scandir(3) instead of readdir(3)
 
-* usplash
+* usplash (Deprecated)
 ** TODO [#A] Make it work again
 ** TODO [#B] use scandir(3) instead of readdir(3)
 ** TODO Use [[info:libc:Argz%20Functions][argz_extract]]
@@ -66,6 +66,7 @@
 ** TODO [#C] python-parsedatetime
 ** TODO [#C] systemd/launchd
    http://0pointer.de/blog/projects/systemd.html
+   http://wiki.debian.org/systemd
 ** TODO Separate logging logic to own object
 ** TODO make clients to a dict!
 ** TODO [#A] Limit approval_delay to max gnutls/tls timeout value
@@ -81,6 +82,7 @@
 *** Handle "no D-Bus server" and/or "no Mandos server found" better
 *** [#B] --dump option
 ** TODO Support RFC 3339 time duration syntax
+** TODO Send milliseconds if bare integer is passed as time duration
 
 * TODO mandos-dispatch
   Listens for specified D-Bus signals and spawns shell commands with
@@ -114,8 +116,8 @@
    From XML sources directly?
 
 * Side Stuff
-** TODO Locate which packet move the other bin/sh when busy box is deactivated
-** TODO contact owner of packet, and ask them to have that shell static in position regardless of busybox
+** TODO Locate which package moves the other bin/sh when busybox is deactivated
+** TODO contact owner of package, and ask them to have that shell static in position regardless of busybox
 
 
 #+STARTUP: showall

=== modified file 'common.ent'
--- common.ent	2011-07-27 17:58:27 +0000
+++ common.ent	2011-10-15 16:48:03 +0000
@@ -1,3 +1,3 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!-- Edited by Makefile -->
-<!ENTITY version "1.3.1">
+<!ENTITY version "1.4.1">

=== modified file 'debian/changelog'
--- debian/changelog	2011-07-27 17:58:27 +0000
+++ debian/changelog	2011-10-15 16:48:03 +0000
@@ -1,3 +1,35 @@
+mandos (1.4.1-1) unstable; urgency=low
+
+  * New upstream release.
+  * debian/control (Build-Depends): Added "man".
+  * debian/control (Conflicts): Changed to "Breaks:".
+  * debian/copyright: Updated format.
+  * debian/mandos-client.postinst: Use "set -e" instead of "#!/bin/sh -e".
+  * debian/mandos-client.postrm: - '' -
+  * debian/mandos.postinst: - '' -
+  * debian/mandos.prerm: Consistent magic.
+
+ -- Björn Påhlsson <belorn@fukt.bsnet.se>  Sat, 15 Oct 2011 18:18:52 +0200
+
+mandos (1.4.0-1) unstable; urgency=low
+
+  * New upstream release.
+  * Fix "FTBFS with binutils-gold": Added "-Xlinker --as-needed" to
+    LDFLAGS in Makefile. (Closes: #632145)
+  * Fix "/run transition: uses obsolete /dev/.initramfs": Try both old and
+    new PID file locations. (Closes: #643554)
+  * debian/source/local-options: New; contains "--single-debian-patch".
+  * debian/control (Standards-Version): Upgraded to "3.9.2".
+    (DM-Upload-Allowed): New; set to "yes".
+  * debian/control: Changed domain from "fukt.bsnet.se" to "recompile.se".
+  * debian/copyright: - '' -
+  * debian/mandos-client.README.Debian: - '' -
+  * debian/mandos.README.Debian: - '' -
+  * debian/watch: - '' -
+  * debian/control (mandos/Description): Fix language to placate lintian.
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Sun, 09 Oct 2011 19:15:08 +0200
+
 mandos (1.3.1-1) unstable; urgency=low
 
   * New upstream release.

=== modified file 'debian/control'
--- debian/control	2011-10-05 16:00:56 +0000
+++ debian/control	2011-10-11 19:36:00 +0000
@@ -6,11 +6,12 @@
 	   Björn Påhlsson <belorn@recompile.se>
 Build-Depends: debhelper (>= 7), docbook-xml, docbook-xsl,
 	libavahi-core-dev, libgpgme11-dev, libgnutls-dev, xsltproc,
-	pkg-config
-Standards-Version: 3.9.1
+	pkg-config, man
+Standards-Version: 3.9.2
 Vcs-Bzr: http://ftp.recompile.se/pub/mandos/trunk
 Vcs-Browser: http://bzr.recompile.se/loggerhead/mandos/trunk/files
 Homepage: http://www.recompile.se/mandos
+DM-Upload-Allowed: yes
 
 Package: mandos
 Architecture: all
@@ -37,7 +38,7 @@
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, cryptsetup,
 	gnupg (<< 2)
-Conflicts: dropbear (<= 0.52-5)
+Breaks: dropbear (<= 0.53.1-1)
 Enhances: cryptsetup
 Description: do unattended reboots with an encrypted root file system
  This is the client part of the Mandos system, which allows

=== modified file 'debian/copyright'
--- debian/copyright	2011-10-05 16:00:56 +0000
+++ debian/copyright	2011-10-10 20:29:58 +0000
@@ -1,8 +1,7 @@
-Format-Specification:
- http://wiki.debian.org/Proposals/CopyrightFormat?action=recall&rev=233
+Format: http://anonscm.debian.org/viewvc/dep/web/deps/dep5.mdwn?revision=202
 Upstream-Name: Mandos
-Upstream-Maintainer: Mandos Maintainers <mandos@recompile.se>
-Upstream-Source: <http://www.recompile.se/mandos>
+Upstream-Contact: Mandos <mandos@recompile.se>
+Source: <http://www.recompile.se/mandos>
 
 Files: *
 Copyright: Copyright © 2008-2011 Teddy Hogeborn

=== modified file 'debian/mandos-client.postinst'
--- debian/mandos-client.postinst	2009-05-24 23:36:15 +0000
+++ debian/mandos-client.postinst	2011-10-10 20:29:58 +0000
@@ -1,4 +1,4 @@
-#!/bin/sh -e
+#!/bin/sh
 # This script can be called in the following ways:
 #
 # After the package was installed:
@@ -15,6 +15,8 @@
 # If prerm fails during replacement due to conflict:
 #       <postinst> abort-remove in-favour <new-package> <version>
 
+set -e
+
 # Update the initial RAM file system image
 update_initramfs()
 {

=== modified file 'debian/mandos-client.postrm'
--- debian/mandos-client.postrm	2011-02-27 17:00:41 +0000
+++ debian/mandos-client.postrm	2011-10-10 20:29:58 +0000
@@ -1,4 +1,4 @@
-#!/bin/sh -e
+#!/bin/sh
 # This script can be called in the following ways:
 #
 # After the package was removed:
@@ -26,6 +26,7 @@
 # If preinst fails during upgrade:
 #       <new-postrm> abort-upgrade <old-version>
 
+set -e
 
 # Update the initial RAM file system image
 update_initramfs()

=== modified file 'debian/mandos.postinst'
--- debian/mandos.postinst	2009-05-24 23:28:04 +0000
+++ debian/mandos.postinst	2011-10-10 20:29:58 +0000
@@ -1,4 +1,4 @@
-#!/bin/sh -e
+#!/bin/sh
 # This script can be called in the following ways:
 #
 # After the package was installed:
@@ -15,6 +15,8 @@
 # If prerm fails during replacement due to conflict:
 #       <postinst> abort-remove in-favour <new-package> <version>
 
+set -e
+
 case "$1" in
     configure)
 	# Rename old "mandos" user and group

=== modified file 'debian/mandos.prerm'
--- debian/mandos.prerm	2009-01-18 00:16:57 +0000
+++ debian/mandos.prerm	2011-10-10 20:29:58 +0000
@@ -1,4 +1,4 @@
-#! /bin/sh
+#!/bin/sh
 # prerm script for mandos
 #
 # see: dh_installdeb(1)

=== added file 'debian/source/local-options'
--- debian/source/local-options	1970-01-01 00:00:00 +0000
+++ debian/source/local-options	2011-10-08 21:13:46 +0000
@@ -0,0 +1,1 @@
+--single-debian-patch

=== modified file 'initramfs-tools-hook'
--- initramfs-tools-hook	2010-09-09 18:16:14 +0000
+++ initramfs-tools-hook	2011-10-05 16:56:06 +0000
@@ -131,7 +131,7 @@
 	"${DESTDIR}${CONFDIR}/plugin-runner.conf"
 fi
 
-# Key files 
+# Key files
 for file in "$keydir"/*; do
     if [ -d "$file" ]; then
 	continue

=== modified file 'mandos'
--- mandos	2011-10-05 16:00:56 +0000
+++ mandos	2011-10-15 16:48:03 +0000
@@ -83,7 +83,7 @@
         SO_BINDTODEVICE = None
 
 
-version = "1.3.1"
+version = "1.4.1"
 
 #logger = logging.getLogger('mandos')
 logger = logging.Logger('mandos')
@@ -160,7 +160,8 @@
                             " after %i retries, exiting.",
                             self.rename_count)
             raise AvahiServiceError("Too many renames")
-        self.name = unicode(self.server.GetAlternativeServiceName(self.name))
+        self.name = unicode(self.server
+                            .GetAlternativeServiceName(self.name))
         logger.info("Changing Zeroconf service name to %r ...",
                     self.name)
         syslogger.setFormatter(logging.Formatter
@@ -321,7 +322,7 @@
     
     def extended_timeout_milliseconds(self):
         "Return the 'extended_timeout' attribute in milliseconds"
-        return _timedelta_to_milliseconds(self.extended_timeout)    
+        return _timedelta_to_milliseconds(self.extended_timeout)
     
     def interval_milliseconds(self):
         "Return the 'interval' attribute in milliseconds"
@@ -361,7 +362,8 @@
         self.last_enabled = None
         self.last_checked_ok = None
         self.timeout = string_to_delta(config["timeout"])
-        self.extended_timeout = string_to_delta(config["extended_timeout"])
+        self.extended_timeout = string_to_delta(config
+                                                ["extended_timeout"])
         self.interval = string_to_delta(config["interval"])
         self.disable_hook = disable_hook
         self.checker = None
@@ -380,13 +382,15 @@
             config["approval_delay"])
         self.approval_duration = string_to_delta(
             config["approval_duration"])
-        self.changedstate = multiprocessing_manager.Condition(multiprocessing_manager.Lock())
+        self.changedstate = (multiprocessing_manager
+                             .Condition(multiprocessing_manager
+                                        .Lock()))
     
     def send_changedstate(self):
         self.changedstate.acquire()
         self.changedstate.notify_all()
         self.changedstate.release()
-        
+    
     def enable(self):
         """Start this client's checker and timeout hooks"""
         if getattr(self, "enabled", False):
@@ -460,11 +464,13 @@
         if timeout is None:
             timeout = self.timeout
         self.last_checked_ok = datetime.datetime.utcnow()
-        gobject.source_remove(self.disable_initiator_tag)
-        self.expires = datetime.datetime.utcnow() + timeout
-        self.disable_initiator_tag = (gobject.timeout_add
-                                      (_timedelta_to_milliseconds(timeout),
-                                       self.disable))
+        if self.disable_initiator_tag is not None:
+            gobject.source_remove(self.disable_initiator_tag)
+        if getattr(self, "enabled", False):
+            self.disable_initiator_tag = (gobject.timeout_add
+                                          (_timedelta_to_milliseconds
+                                           (timeout), self.disable))
+            self.expires = datetime.datetime.utcnow() + timeout
     
     def need_approval(self):
         self.last_approval_request = datetime.datetime.utcnow()
@@ -629,15 +635,18 @@
         """
         return ((prop.__get__(self)._dbus_name, prop.__get__(self))
                 for cls in self.__class__.__mro__
-                for name, prop in inspect.getmembers(cls, self._is_dbus_property))
+                for name, prop in
+                inspect.getmembers(cls, self._is_dbus_property))
     
     def _get_dbus_property(self, interface_name, property_name):
         """Returns a bound method if one exists which is a D-Bus
         property with the specified name and interface.
         """
         for cls in  self.__class__.__mro__:
-            for name, value in inspect.getmembers(cls, self._is_dbus_property):
-                if value._dbus_name == property_name and value._dbus_interface == interface_name:
+            for name, value in (inspect.getmembers
+                                (cls, self._is_dbus_property)):
+                if (value._dbus_name == property_name
+                    and value._dbus_interface == interface_name):
                     return value.__get__(self)
         
         # No such property
@@ -754,7 +763,8 @@
     return dbus.String(dt.isoformat(),
                        variant_level=variant_level)
 
-class AlternateDBusNamesMetaclass(DBusObjectWithProperties.__metaclass__):
+class AlternateDBusNamesMetaclass(DBusObjectWithProperties
+                                  .__metaclass__):
     """Applied to an empty subclass of a D-Bus object, this metaclass
     will add additional D-Bus attributes matching a certain pattern.
     """
@@ -883,25 +893,27 @@
         """ Modify a variable so that it's a property which announces
         its changes to DBus.
 
-        transform_fun: Function that takes a value and transforms it
-                       to a D-Bus type.
+        transform_fun: Function that takes a value and a variant_level
+                       and transforms it to a D-Bus type.
         dbus_name: D-Bus name of the variable
         type_func: Function that transform the value before sending it
                    to the D-Bus.  Default: no transform
         variant_level: D-Bus variant level.  Default: 1
         """
-        real_value = [None,]
+        attrname = "_{0}".format(dbus_name)
         def setter(self, value):
-            old_value = real_value[0]
-            real_value[0] = value
             if hasattr(self, "dbus_object_path"):
-                if type_func(old_value) != type_func(real_value[0]):
-                    dbus_value = transform_func(type_func(real_value[0]),
-                                                variant_level)
+                if (not hasattr(self, attrname) or
+                    type_func(getattr(self, attrname, None))
+                    != type_func(value)):
+                    dbus_value = transform_func(type_func(value),
+                                                variant_level
+                                                =variant_level)
                     self.PropertyChanged(dbus.String(dbus_name),
                                          dbus_value)
+            setattr(self, attrname, value)
         
-        return property(lambda self: real_value[0], setter)
+        return property(lambda self: getattr(self, attrname), setter)
     
     
     expires = notifychangeproperty(datetime_to_dbus, "Expires")
@@ -912,24 +924,32 @@
     last_enabled = notifychangeproperty(datetime_to_dbus,
                                         "LastEnabled")
     checker = notifychangeproperty(dbus.Boolean, "CheckerRunning",
-                                   type_func = lambda checker: checker is not None)
+                                   type_func = lambda checker:
+                                       checker is not None)
     last_checked_ok = notifychangeproperty(datetime_to_dbus,
                                            "LastCheckedOK")
-    last_approval_request = notifychangeproperty(datetime_to_dbus,
-                                                 "LastApprovalRequest")
+    last_approval_request = notifychangeproperty(
+        datetime_to_dbus, "LastApprovalRequest")
     approved_by_default = notifychangeproperty(dbus.Boolean,
                                                "ApprovedByDefault")
-    approval_delay = notifychangeproperty(dbus.UInt16, "ApprovalDelay",
-                                          type_func = _timedelta_to_milliseconds)
-    approval_duration = notifychangeproperty(dbus.UInt16, "ApprovalDuration",
-                                             type_func = _timedelta_to_milliseconds)
+    approval_delay = notifychangeproperty(dbus.UInt16,
+                                          "ApprovalDelay",
+                                          type_func =
+                                          _timedelta_to_milliseconds)
+    approval_duration = notifychangeproperty(
+        dbus.UInt16, "ApprovalDuration",
+        type_func = _timedelta_to_milliseconds)
     host = notifychangeproperty(dbus.String, "Host")
     timeout = notifychangeproperty(dbus.UInt16, "Timeout",
-                                   type_func = _timedelta_to_milliseconds)
-    extended_timeout = notifychangeproperty(dbus.UInt16, "ExtendedTimeout",
-                                            type_func = _timedelta_to_milliseconds)
-    interval = notifychangeproperty(dbus.UInt16, "Interval",
-                                    type_func = _timedelta_to_milliseconds)
+                                   type_func =
+                                   _timedelta_to_milliseconds)
+    extended_timeout = notifychangeproperty(
+        dbus.UInt16, "ExtendedTimeout",
+        type_func = _timedelta_to_milliseconds)
+    interval = notifychangeproperty(dbus.UInt16,
+                                    "Interval",
+                                    type_func =
+                                    _timedelta_to_milliseconds)
     checker_command = notifychangeproperty(dbus.String, "Checker")
     
     del notifychangeproperty
@@ -1170,18 +1190,18 @@
         gobject.source_remove(self.disable_initiator_tag)
         self.disable_initiator_tag = None
         self.expires = None
-        time_to_die = (self.
-                       _timedelta_to_milliseconds((self
-                                                   .last_checked_ok
-                                                   + self.timeout)
-                                                  - datetime.datetime
-                                                  .utcnow()))
+        time_to_die = _timedelta_to_milliseconds((self
+                                                  .last_checked_ok
+                                                  + self.timeout)
+                                                 - datetime.datetime
+                                                 .utcnow())
         if time_to_die <= 0:
             # The timeout has passed
             self.disable()
         else:
             self.expires = (datetime.datetime.utcnow()
-                            + datetime.timedelta(milliseconds = time_to_die))
+                            + datetime.timedelta(milliseconds =
+                                                 time_to_die))
             self.disable_initiator_tag = (gobject.timeout_add
                                           (time_to_die, self.disable))
     
@@ -1353,7 +1373,7 @@
                                        client.name)
                         if self.server.use_dbus:
                             # Emit D-Bus signal
-                            client.Rejected("Disabled")                    
+                            client.Rejected("Disabled")
                         return
                     
                     if client._approved or not client.approval_delay:
@@ -1376,10 +1396,11 @@
                         return
                     
                     #wait until timeout or approved
-                    #x = float(client._timedelta_to_milliseconds(delay))
                     time = datetime.datetime.now()
                     client.changedstate.acquire()
-                    client.changedstate.wait(float(client._timedelta_to_milliseconds(delay) / 1000))
+                    (client.changedstate.wait
+                     (float(client._timedelta_to_milliseconds(delay)
+                            / 1000)))
                     client.changedstate.release()
                     time2 = datetime.datetime.now()
                     if (time2 - time) >= delay:
@@ -1409,7 +1430,7 @@
                     sent_size += sent
                 
                 logger.info("Sending secret to %s", client.name)
-                # bump the timeout as if seen
+                # bump the timeout using extended_timeout
                 client.checked_ok(client.extended_timeout)
                 if self.server.use_dbus:
                     # Emit D-Bus signal
@@ -1495,11 +1516,14 @@
         except:
             self.handle_error(request, address)
         self.close_request(request)
-            
+    
     def process_request(self, request, address):
         """Start a new process to process the request."""
-        multiprocessing.Process(target = self.sub_process_main,
-                                args = (request, address)).start()
+        proc = multiprocessing.Process(target = self.sub_process_main,
+                                       args = (request,
+                                               address))
+        proc.start()
+        return proc
 
 
 class MultiprocessingMixInWithPipe(MultiprocessingMixIn, object):
@@ -1511,12 +1535,12 @@
         """
         parent_pipe, self.child_pipe = multiprocessing.Pipe()
         
-        super(MultiprocessingMixInWithPipe,
-              self).process_request(request, client_address)
+        proc = MultiprocessingMixIn.process_request(self, request,
+                                                    client_address)
         self.child_pipe.close()
-        self.add_pipe(parent_pipe)
+        self.add_pipe(parent_pipe, proc)
     
-    def add_pipe(self, parent_pipe):
+    def add_pipe(self, parent_pipe, proc):
         """Dummy function; override as necessary"""
         raise NotImplementedError
 
@@ -1610,17 +1634,21 @@
     def server_activate(self):
         if self.enabled:
             return socketserver.TCPServer.server_activate(self)
+    
     def enable(self):
         self.enabled = True
-    def add_pipe(self, parent_pipe):
+    
+    def add_pipe(self, parent_pipe, proc):
         # Call "handle_ipc" for both data and EOF events
         gobject.io_add_watch(parent_pipe.fileno(),
                              gobject.IO_IN | gobject.IO_HUP,
                              functools.partial(self.handle_ipc,
-                                               parent_pipe = parent_pipe))
-        
+                                               parent_pipe =
+                                               parent_pipe,
+                                               proc = proc))
+    
     def handle_ipc(self, source, condition, parent_pipe=None,
-                   client_object=None):
+                   proc = None, client_object=None):
         condition_names = {
             gobject.IO_IN: "IN",   # There is data to read.
             gobject.IO_OUT: "OUT", # Data can be written (without
@@ -1635,8 +1663,10 @@
                                        for cond, name in
                                        condition_names.iteritems()
                                        if cond & condition)
-        # error or the other end of multiprocessing.Pipe has closed
+        # error, or the other end of multiprocessing.Pipe has closed
         if condition & (gobject.IO_ERR | condition & gobject.IO_HUP):
+            # Wait for other process to exit
+            proc.join()
             return False
         
         # Read a request from the child
@@ -1656,31 +1686,39 @@
                             "dress: %s", fpr, address)
                 if self.use_dbus:
                     # Emit D-Bus signal
-                    mandos_dbus_service.ClientNotFound(fpr, address[0])
+                    mandos_dbus_service.ClientNotFound(fpr,
+                                                       address[0])
                 parent_pipe.send(False)
                 return False
             
             gobject.io_add_watch(parent_pipe.fileno(),
                                  gobject.IO_IN | gobject.IO_HUP,
                                  functools.partial(self.handle_ipc,
-                                                   parent_pipe = parent_pipe,
-                                                   client_object = client))
+                                                   parent_pipe =
+                                                   parent_pipe,
+                                                   proc = proc,
+                                                   client_object =
+                                                   client))
             parent_pipe.send(True)
-            # remove the old hook in favor of the new above hook on same fileno
+            # remove the old hook in favor of the new above hook on
+            # same fileno
             return False
         if command == 'funcall':
             funcname = request[1]
             args = request[2]
             kwargs = request[3]
             
-            parent_pipe.send(('data', getattr(client_object, funcname)(*args, **kwargs)))
+            parent_pipe.send(('data', getattr(client_object,
+                                              funcname)(*args,
+                                                         **kwargs)))
         
         if command == 'getattr':
             attrname = request[1]
             if callable(client_object.__getattribute__(attrname)):
                 parent_pipe.send(('function',))
             else:
-                parent_pipe.send(('data', client_object.__getattribute__(attrname)))
+                parent_pipe.send(('data', client_object
+                                  .__getattribute__(attrname)))
         
         if command == 'setattr':
             attrname = request[1]
@@ -1977,8 +2015,9 @@
         try:
             bus_name = dbus.service.BusName("se.recompile.Mandos",
                                             bus, do_not_queue=True)
-            old_bus_name = dbus.service.BusName("se.bsnet.fukt.Mandos",
-                                                bus, do_not_queue=True)
+            old_bus_name = (dbus.service.BusName
+                            ("se.bsnet.fukt.Mandos", bus,
+                             do_not_queue=True))
         except dbus.exceptions.NameExistsException as e:
             logger.error(unicode(e) + ", disabling D-Bus")
             use_dbus = False
@@ -1997,7 +2036,8 @@
     
     client_class = Client
     if use_dbus:
-        client_class = functools.partial(ClientDBusTransitional, bus = bus)        
+        client_class = functools.partial(ClientDBusTransitional,
+                                         bus = bus)
     def client_config_items(config, section):
         special_settings = {
             "approved_by_default":
@@ -2098,6 +2138,7 @@
         "Cleanup function; run on exit"
         service.cleanup()
         
+        multiprocessing.active_children()
         while tcp_server.clients:
             client = tcp_server.clients.pop()
             if use_dbus:
@@ -2107,7 +2148,8 @@
             client.disable(quiet=True)
             if use_dbus:
                 # Emit D-Bus signal
-                mandos_dbus_service.ClientRemoved(client.dbus_object_path,
+                mandos_dbus_service.ClientRemoved(client
+                                                  .dbus_object_path,
                                                   client.name)
     
     atexit.register(cleanup)

=== modified file 'mandos-clients.conf.xml'
--- mandos-clients.conf.xml	2011-10-05 16:00:56 +0000
+++ mandos-clients.conf.xml	2011-10-10 20:29:58 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos-clients.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/clients.conf</filename>">
-<!ENTITY TIMESTAMP "2011-10-03">
+<!ENTITY TIMESTAMP "2011-10-10">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -190,7 +190,7 @@
 	  </para>
 	  <para>
 	    Extended timeout is an added timeout that is given once
-	    after a password has been sent sucessfully to a client.
+	    after a password has been sent successfully to a client.
 	    The timeout is by default longer than the normal timeout,
 	    and is used for handling the extra long downtime while a
 	    machine is booting up.  Time to take into consideration

=== modified file 'mandos-ctl'
--- mandos-ctl	2011-10-05 16:00:56 +0000
+++ mandos-ctl	2011-10-15 16:48:03 +0000
@@ -3,8 +3,8 @@
 # 
 # Mandos Monitor - Control and monitor the Mandos server
 # 
-# Copyright © 2008-2010 Teddy Hogeborn
-# Copyright © 2008-2010 Björn Påhlsson
+# Copyright © 2008-2011 Teddy Hogeborn
+# Copyright © 2008-2011 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -60,7 +60,7 @@
 server_path = "/"
 server_interface = domain + ".Mandos"
 client_interface = domain + ".Mandos.Client"
-version = "1.3.1"
+version = "1.4.1"
 
 def timedelta_to_milliseconds(td):
     """Convert a datetime.timedelta object to milliseconds"""
@@ -301,41 +301,41 @@
                                          dbus_interface=
                                          dbus.PROPERTIES_IFACE)
                          else 1)
-            if options.checker:
+            if options.checker is not None:
                 client.Set(client_interface, "Checker",
                            options.checker,
                            dbus_interface=dbus.PROPERTIES_IFACE)
-            if options.host:
+            if options.host is not None:
                 client.Set(client_interface, "Host", options.host,
                            dbus_interface=dbus.PROPERTIES_IFACE)
-            if options.interval:
+            if options.interval is not None:
                 client.Set(client_interface, "Interval",
                            timedelta_to_milliseconds
                            (string_to_delta(options.interval)),
                            dbus_interface=dbus.PROPERTIES_IFACE)
-            if options.approval_delay:
+            if options.approval_delay is not None:
                 client.Set(client_interface, "ApprovalDelay",
                            timedelta_to_milliseconds
                            (string_to_delta(options.
                                             approval_delay)),
                            dbus_interface=dbus.PROPERTIES_IFACE)
-            if options.approval_duration:
+            if options.approval_duration is not None:
                 client.Set(client_interface, "ApprovalDuration",
                            timedelta_to_milliseconds
                            (string_to_delta(options.
                                             approval_duration)),
                            dbus_interface=dbus.PROPERTIES_IFACE)
-            if options.timeout:
+            if options.timeout is not None:
                 client.Set(client_interface, "Timeout",
                            timedelta_to_milliseconds
                            (string_to_delta(options.timeout)),
                            dbus_interface=dbus.PROPERTIES_IFACE)
-            if options.extended_timeout:
+            if options.extended_timeout is not None:
                 client.Set(client_interface, "ExtendedTimeout",
                            timedelta_to_milliseconds
                            (string_to_delta(options.extended_timeout)),
                            dbus_interface=dbus.PROPERTIES_IFACE)
-            if options.secret:
+            if options.secret is not None:
                 client.Set(client_interface, "Secret",
                            dbus.ByteArray(open(options.secret,
                                                "rb").read()),

=== modified file 'mandos-keygen'
--- mandos-keygen	2011-10-05 16:00:56 +0000
+++ mandos-keygen	2011-10-15 16:48:03 +0000
@@ -21,7 +21,7 @@
 # Contact the authors at <mandos@recompile.se>.
 # 
 
-VERSION="1.3.1"
+VERSION="1.4.1"
 
 KEYDIR="/etc/keys/mandos"
 KEYTYPE=DSA

=== modified file 'mandos-monitor'
--- mandos-monitor	2011-10-05 16:00:56 +0000
+++ mandos-monitor	2011-10-15 16:48:03 +0000
@@ -52,7 +52,7 @@
 domain = 'se.recompile'
 server_interface = domain + '.Mandos'
 client_interface = domain + '.Mandos.Client'
-version = "1.3.1"
+version = "1.4.1"
 
 # Always run in monochrome mode
 urwid.curses_display.curses.has_colors = lambda : False

=== modified file 'mandos.lsm'
--- mandos.lsm	2011-10-05 16:00:56 +0000
+++ mandos.lsm	2011-10-15 16:48:03 +0000
@@ -1,7 +1,7 @@
 Begin4
 Title:		Mandos
-Version:	1.3.1
-Entered-date:	2011-07-27
+Version:	1.4.1
+Entered-date:	2011-10-15
 Description:	The Mandos system allows computers to have encrypted
 root file systems and at the same time be capable of remote and/or
 unattended reboots.
@@ -12,9 +12,9 @@
 Maintained-by:	teddy@recompile.se (Teddy Hogeborn),
 		belorn@recompile.se (Björn Påhlsson)
 Primary-site: http://www.recompile.se/mandos
-	      136K mandos_1.3.1.orig.tar.gz
+	      138K mandos_1.4.1.orig.tar.gz
 Alternate-site: ftp://ftp.recompile.se/pub/mandos
-		136K mandos_1.3.1.orig.tar.gz
+		138K mandos_1.4.1.orig.tar.gz
 Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.6, and
 various other libraries.  While made for Debian GNU/Linux, it is
 probably portable to other distributions, but not other Unixes.

=== modified file 'plugin-runner.c'
--- plugin-runner.c	2011-10-05 16:00:56 +0000
+++ plugin-runner.c	2011-10-09 12:32:13 +0000
@@ -2,8 +2,8 @@
 /*
  * Mandos plugin runner - Run Mandos plugins
  *
- * Copyright © 2008-2010 Teddy Hogeborn
- * Copyright © 2008-2010 Björn Påhlsson
+ * Copyright © 2008-2011 Teddy Hogeborn
+ * Copyright © 2008-2011 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as

=== modified file 'plugin-runner.xml'
--- plugin-runner.xml	2011-10-05 16:00:56 +0000
+++ plugin-runner.xml	2011-10-05 16:56:06 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "plugin-runner">
-<!ENTITY TIMESTAMP "2011-10-03">
+<!ENTITY TIMESTAMP "2011-10-05">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -261,7 +261,7 @@
 	    Disable the plugin named
 	    <replaceable>PLUGIN</replaceable>.  The plugin will not be
 	    started.
-	  </para>	
+	  </para>
 	</listitem>
       </varlistentry>
       

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2011-10-05 16:00:56 +0000
+++ plugins.d/mandos-client.c	2011-11-11 09:07:09 +0000
@@ -1085,107 +1085,84 @@
   errno = old_errno;
 }
 
-/* 
- * This function determines if a directory entry in /sys/class/net
- * corresponds to an acceptable network device.
- * (This function is passed to scandir(3) as a filter function.)
- */
-int good_interface(const struct dirent *if_entry){
-  ssize_t ssret;
-  char *flagname = NULL;
-  if(if_entry->d_name[0] == '.'){
-    return 0;
-  }
-  int ret = asprintf(&flagname, "%s/%s/flags", sys_class_net,
-		     if_entry->d_name);
-  if(ret < 0){
-    perror_plus("asprintf");
-    return 0;
-  }
-  int flags_fd = (int)TEMP_FAILURE_RETRY(open(flagname, O_RDONLY));
-  if(flags_fd == -1){
-    perror_plus("open");
-    free(flagname);
-    return 0;
-  }
-  free(flagname);
-  typedef short ifreq_flags;	/* ifreq.ifr_flags in netdevice(7) */
-  /* read line from flags_fd */
-  ssize_t to_read = 2+(sizeof(ifreq_flags)*2)+1; /* "0x1003\n" */
-  char *flagstring = malloc((size_t)to_read+1); /* +1 for final \0 */
-  flagstring[(size_t)to_read] = '\0';
-  if(flagstring == NULL){
-    perror_plus("malloc");
-    close(flags_fd);
-    return 0;
-  }
-  while(to_read > 0){
-    ssret = (ssize_t)TEMP_FAILURE_RETRY(read(flags_fd, flagstring,
-					     (size_t)to_read));
-    if(ssret == -1){
-      perror_plus("read");
-      free(flagstring);
-      close(flags_fd);
-      return 0;
-    }
-    to_read -= ssret;
-    if(ssret == 0){
-      break;
-    }
-  }
-  close(flags_fd);
-  intmax_t tmpmax;
-  char *tmp;
-  errno = 0;
-  tmpmax = strtoimax(flagstring, &tmp, 0);
-  if(errno != 0 or tmp == flagstring or (*tmp != '\0'
-					 and not (isspace(*tmp)))
-     or tmpmax != (ifreq_flags)tmpmax){
+bool get_flags(const char *ifname, struct ifreq *ifr){
+  int ret;
+  
+  int s = socket(PF_INET6, SOCK_DGRAM, IPPROTO_IP);
+  if(s < 0){
+    perror_plus("socket");
+    return false;
+  }
+  strcpy(ifr->ifr_name, ifname);
+  ret = ioctl(s, SIOCGIFFLAGS, ifr);
+  if(ret == -1){
     if(debug){
-      fprintf(stderr, "Invalid flags \"%s\" for interface \"%s\"\n",
-	      flagstring, if_entry->d_name);
+      perror_plus("ioctl SIOCGIFFLAGS");
     }
-    free(flagstring);
-    return 0;
+    return false;
   }
-  free(flagstring);
-  ifreq_flags flags = (ifreq_flags)tmpmax;
+  return true;
+}
+
+bool good_flags(const char *ifname, const struct ifreq *ifr){
+  
   /* Reject the loopback device */
-  if(flags & IFF_LOOPBACK){
+  if(ifr->ifr_flags & IFF_LOOPBACK){
     if(debug){
       fprintf(stderr, "Rejecting loopback interface \"%s\"\n",
-	      if_entry->d_name);
+	      ifname);
     }
-    return 0;
+    return false;
   }
   /* Accept point-to-point devices only if connect_to is specified */
-  if(connect_to != NULL and (flags & IFF_POINTOPOINT)){
+  if(connect_to != NULL and (ifr->ifr_flags & IFF_POINTOPOINT)){
     if(debug){
       fprintf(stderr, "Accepting point-to-point interface \"%s\"\n",
-	      if_entry->d_name);
+	      ifname);
     }
-    return 1;
+    return true;
   }
   /* Otherwise, reject non-broadcast-capable devices */
-  if(not (flags & IFF_BROADCAST)){
+  if(not (ifr->ifr_flags & IFF_BROADCAST)){
     if(debug){
       fprintf(stderr, "Rejecting non-broadcast interface \"%s\"\n",
-	      if_entry->d_name);
+	      ifname);
     }
-    return 0;
+    return false;
   }
   /* Reject non-ARP interfaces (including dummy interfaces) */
-  if(flags & IFF_NOARP){
+  if(ifr->ifr_flags & IFF_NOARP){
     if(debug){
-      fprintf(stderr, "Rejecting non-ARP interface \"%s\"\n",
-	      if_entry->d_name);
+      fprintf(stderr, "Rejecting non-ARP interface \"%s\"\n", ifname);
     }
-    return 0;
+    return false;
   }
+  
   /* Accept this device */
   if(debug){
-    fprintf(stderr, "Interface \"%s\" is acceptable\n",
-	    if_entry->d_name);
+    fprintf(stderr, "Interface \"%s\" is good\n", ifname);
+  }
+  return true;
+}
+
+/* 
+ * This function determines if a directory entry in /sys/class/net
+ * corresponds to an acceptable network device.
+ * (This function is passed to scandir(3) as a filter function.)
+ */
+int good_interface(const struct dirent *if_entry){
+  int ret;
+  if(if_entry->d_name[0] == '.'){
+    return 0;
+  }
+  struct ifreq ifr;
+
+  if(not get_flags(if_entry->d_name, &ifr)){
+    return 0;
+  }
+  
+  if(not good_flags(if_entry->d_name, &ifr)){
+    return 0;
   }
   return 1;
 }

=== modified file 'plugins.d/password-prompt.c'
--- plugins.d/password-prompt.c	2011-10-05 16:00:56 +0000
+++ plugins.d/password-prompt.c	2011-10-09 12:32:13 +0000
@@ -2,8 +2,8 @@
 /*
  * Password-prompt - Read a password from the terminal and print it
  * 
- * Copyright © 2008-2010 Teddy Hogeborn
- * Copyright © 2008-2010 Björn Påhlsson
+ * Copyright © 2008-2011 Teddy Hogeborn
+ * Copyright © 2008-2011 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as

